# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['proxybroker2', 'proxybroker2.data']

package_data = \
{'': ['*']}

install_requires = \
['aiodns>=3.0.0,<4.0.0',
 'aiohttp>=3.8.1,<4.0.0',
 'attrs>=22.1.0,<23.0.0',
 'cachetools>=5.2.0,<6.0.0',
 'click>=8.1.3,<9.0.0',
 'maxminddb>=2.2.0,<3.0.0']

entry_points = \
{'console_scripts': ['pb2 = proxybroker2.cli:cli',
                     'proxybroker2 = proxybroker2.cli:cli']}

setup_kwargs = {
    'name': 'proxybroker2',
    'version': '2.0.0a4',
    'description': 'The New (auto rotate) Proxy [Finder | Checker | Server]. HTTP(S) & SOCKS.',
    'long_description': 'ProxyBroker\n<!-- ALL-CONTRIBUTORS-BADGE:START - Do not remove or modify this section -->\n[![All Contributors](https://img.shields.io/badge/all_contributors-8-orange.svg?style=flat-square)](#contributors-)\n<!-- ALL-CONTRIBUTORS-BADGE:END -->\n===========\n\n[![Quality Gate Status](https://sonarcloud.io/api/project_badges/measure?project=bluet_proxybroker2&metric=alert_status)](https://sonarcloud.io/summary/new_code?id=bluet_proxybroker2)\n![test result](https://github.com/bluet/proxybroker2/actions/workflows/python-test-versions.yml/badge.svg)\n[![GitHub issues](https://img.shields.io/github/issues/bluet/proxybroker2)](https://github.com/bluet/proxybroker2/issues)\n[![GitHub stars](https://img.shields.io/github/stars/bluet/proxybroker2)](https://github.com/bluet/proxybroker2/stargazers)\n[![GitHub forks](https://img.shields.io/github/forks/bluet/proxybroker2)](https://github.com/bluet/proxybroker2/network)\n[![GitHub license](https://img.shields.io/github/license/bluet/proxybroker2)](https://github.com/bluet/proxybroker2/blob/master/LICENSE)\n[![Twitter](https://img.shields.io/twitter/url?style=social&url=https%3A%2F%2Fgithub.com%2Fbluet%2Fproxybroker2)](https://twitter.com/intent/tweet?text=Wow:&url=https%3A%2F%2Fgithub.com%2Fbluet%2Fproxybroker2)\n\nProxyBroker is an open source tool that asynchronously finds public proxies from multiple sources and concurrently checks them.\n\n![image](https://raw.githubusercontent.com/constverum/ProxyBroker/master/docs/source/_static/index_find_example.gif)\n\nFeatures\n--------\n\n-   Finds more than 7000 working proxies from \\~50 sources.\n-   Support protocols: HTTP(S), SOCKS4/5. Also CONNECT method to ports 80 and 23 (SMTP).\n-   Proxies may be filtered by type, anonymity level, response time, country and status in DNSBL.\n-   Work as a proxy server that distributes incoming requests to external proxies. With automatic proxy rotation.\n-   All proxies are checked to support Cookies and Referer (and POST requests if required).\n-   Automatically removes duplicate proxies.\n-   Is asynchronous.\n\nDocker\n------\nDocker Hub https://hub.docker.com/r/bluet/proxybroker2\n\n```\n$ docker run --rm bluet/proxybroker2 --help\n  usage: proxybroker [--max-conn MAX_CONN] [--max-tries MAX_TRIES]\n                     [--timeout SECONDS] [--judge JUDGES] [--provider PROVIDERS]\n                     [--verify-ssl]\n                     [--log [{NOTSET,DEBUG,INFO,WARNING,ERROR,CRITICAL}]]\n                     [--min-queue MINIMUM_PROXIES_IN_QUEUE]\n                     [--version] [--help]\n                     {find,grab,serve,update-geo} ...\n\n  Proxy [Finder | Checker | Server]\n\n  Commands:\n    These are common commands used in various situations\n\n    {find,grab,serve,update-geo}\n      find                Find and check proxies\n      grab                Find proxies without a check\n      serve               Run a local proxy server\n      update-geo          Download and use a detailed GeoIP database\n\n  Options:\n    --max-conn MAX_CONN   The maximum number of concurrent checks of proxies\n    --max-tries MAX_TRIES\n                          The maximum number of attempts to check a proxy\n    --timeout SECONDS, -t SECONDS\n                          Timeout of a request in seconds. The default value is\n                          8 seconds\n    --judge JUDGES        Urls of pages that show HTTP headers and IP address\n    --provider PROVIDERS  Urls of pages where to find proxies\n    --verify-ssl, -ssl    Flag indicating whether to check the SSL certificates\n    --min-queue MINIMUM_PROXIES_IN_QUEUE   The minimum number of proxies in the queue for checking connectivity\n    --log [{NOTSET,DEBUG,INFO,WARNING,ERROR,CRITICAL}]\n                          Logging level\n    --version, -v         Show program\'s version number and exit\n    --help, -h            Show this help message and exit\n\n  Run \'proxybroker <command> --help\' for more information on a command.\n  Suggestions and bug reports are greatly appreciated:\n  <https://github.com/bluet/proxybroker2/issues>\n\n```\n\n\nRequirements\n------------\n\n-   Python 3.8+\n-   [aiohttp](https://pypi.python.org/pypi/aiohttp)\n-   [aiodns](https://pypi.python.org/pypi/aiodns)\n-   [maxminddb](https://pypi.python.org/pypi/maxminddb)\n\nInstallation\n------------\n\n### Install locally\n\nTo install last stable release from pypi:\n> NOT RECOMMEND. It will install the out-dated original proxybroker package, which is no longer maintained by original maintainer. [https://github.com/constverum/ProxyBroker](https://github.com/constverum/ProxyBroker/issues/195)\n> We will upload the up-to-date package under new name (proxybroker2) when the support for 3.10 is ready. [https://github.com/bluet/proxybroker2/issues/89](https://github.com/bluet/proxybroker2/issues/89)\n\n``` {.sourceCode .bash}\n$ pip install proxybroker\n```\n\nTo install the latest development version from GitHub:\n\n``` {.sourceCode .bash}\n$ pip install -U git+https://github.com/bluet/proxybroker2.git\n```\n\n### Use pre-built Docker image\n\n``` {.sourceCode .bash}\n$ docker pull bluet/proxybroker2\n```\n\n### Build bundled one-file executable with pyinstaller\n\n#### Requirements\n\n*On UNIX-like systems (Linux / macOSX / BSD)*\n\nInstall these tools\n - upx\n - objdump (this tool is usually in the binutils package)\n - `$ sudo apt install upx-ucl binutils` (On Ubuntu / Debian)\n\n#### Build\n\n```\npip install pyinstaller \\\n&& pip install . \\\n&& mkdir -p build \\\n&& cd build \\\n&& pyinstaller --onefile --name proxybroker --add-data "../proxybroker/data:data" --workpath ./tmp --distpath . --clean ../py2exe_entrypoint.py \\\n&& rm -rf tmp\n```\n\nThe executable is now in the build directory\n\nUsage\n-----\n\n### CLI Examples\n\n#### Find\n\nFind and show 10 HTTP(S) proxies from United States with the high level of anonymity:\n\n``` {.sourceCode .bash}\n$ proxybroker find --types HTTP HTTPS --lvl High --countries US --strict -l 10\n```\n\n![image](https://raw.githubusercontent.com/constverum/ProxyBroker/master/docs/source/_static/cli_find_example.gif)\n\n#### Grab\n\nFind and save to a file 10 US proxies (without a check):\n\n``` {.sourceCode .bash}\n$ proxybroker grab --countries US --limit 10 --outfile ./proxies.txt\n```\n\n![image](https://raw.githubusercontent.com/constverum/ProxyBroker/master/docs/source/_static/cli_grab_example.gif)\n\n#### Serve\n\nRun a local proxy server that distributes incoming requests to a pool of found HTTP(S) proxies with the high level of anonymity:\n\n``` {.sourceCode .bash}\n$ proxybroker serve --host 127.0.0.1 --port 8888 --types HTTP HTTPS --lvl High --min-queue 5\n```\n\n![image](https://raw.githubusercontent.com/constverum/ProxyBroker/master/docs/source/_static/cli_serve_example.gif)\n\nRun `proxybroker --help` for more information on the options available.\nRun `proxybroker <command> --help` for more information on a command.\n\n### Basic code example\n\nFind and show 10 working HTTP(S) proxies:\n\n``` {.sourceCode .python}\nimport asyncio\nfrom proxybroker import Broker\n\nasync def show(proxies):\n    while True:\n        proxy = await proxies.get()\n        if proxy is None: break\n        print(\'Found proxy: %s\' % proxy)\n\nproxies = asyncio.Queue()\nbroker = Broker(proxies)\ntasks = asyncio.gather(\n    broker.find(types=[\'HTTP\', \'HTTPS\'], limit=10),\n    show(proxies))\n\nloop = asyncio.get_event_loop()\nloop.run_until_complete(tasks)\n```\n\n[More examples](https://proxybroker.readthedocs.io/en/latest/examples.html).\n\n### Proxy information per requests\n#### HTTP\nCheck `X-Proxy-Info` header in response.\n```\n$ http_proxy=http://127.0.0.1:8888 https_proxy=http://127.0.0.1:8888 curl -v http://httpbin.org/get\n*   Trying 127.0.0.1...\n* TCP_NODELAY set\n* Connected to 127.0.0.1 (127.0.0.1) port 8888 (#0)\n> GET http://httpbin.org/get HTTP/1.1\n> Host: httpbin.org\n> User-Agent: curl/7.58.0\n> Accept: */*\n> Proxy-Connection: Keep-Alive\n>\n< HTTP/1.1 200 OK\n< X-Proxy-Info: 174.138.42.112:8080\n< Date: Mon, 04 May 2020 03:39:40 GMT\n< Content-Type: application/json\n< Content-Length: 304\n< Server: gunicorn/19.9.0\n< Access-Control-Allow-Origin: *\n< Access-Control-Allow-Credentials: true\n< X-Cache: MISS from ADM-MANAGER\n< X-Cache-Lookup: MISS from ADM-MANAGER:880\n< Connection: keep-alive\n<\n{\n  "args": {},\n  "headers": {\n    "Accept": "*/*",\n    "Cache-Control": "max-age=259200",\n    "Host": "httpbin.org",\n    "User-Agent": "curl/7.58.0",\n    "X-Amzn-Trace-Id": "Root=1-5eaf8e7c-6a1162a1387a1743a49063f4"\n  },\n  "origin": "...",\n  "url": "http://httpbin.org/get"\n}\n* Connection #0 to host 127.0.0.1 left intact\n```\n\n#### HTTPS\nWe are not able to modify HTTPS traffic to inject custom header once they start being encrypted. A `X-Proxy-Info` will be sent to client after `HTTP/1.1 200 Connection established` but not sure how clients can read it.\n```\n(env) bluet@ocisly:~/workspace/proxybroker2$ http_proxy=http://127.0.0.1:8888 https_proxy=http://127.0.0.1:8888 curl -v https://httpbin.org/get\n*   Trying 127.0.0.1...\n* TCP_NODELAY set\n* Connected to 127.0.0.1 (127.0.0.1) port 8888 (#0)\n* allocate connect buffer!\n* Establish HTTP proxy tunnel to httpbin.org:443\n> CONNECT httpbin.org:443 HTTP/1.1\n> Host: httpbin.org:443\n> User-Agent: curl/7.58.0\n> Proxy-Connection: Keep-Alive\n>\n< HTTP/1.1 200 Connection established\n< X-Proxy-Info: 207.148.22.139:8080\n<\n* Proxy replied 200 to CONNECT request\n* CONNECT phase completed!\n* ALPN, offering h2\n* ALPN, offering http/1.1\n* successfully set certificate verify locations:\n...\n*  SSL certificate verify ok.\n* Using HTTP2, server supports multi-use\n* Connection state changed (HTTP/2 confirmed)\n* Copying HTTP/2 data in stream buffer to connection buffer after upgrade: len=0\n* Using Stream ID: 1 (easy handle 0x5560b2e93580)\n> GET /get HTTP/2\n> Host: httpbin.org\n> User-Agent: curl/7.58.0\n> Accept: */*\n>\n* Connection state changed (MAX_CONCURRENT_STREAMS updated)!\n< HTTP/2 200\n< date: Mon, 04 May 2020 03:39:35 GMT\n< content-type: application/json\n< content-length: 256\n< server: gunicorn/19.9.0\n< access-control-allow-origin: *\n< access-control-allow-credentials: true\n<\n{\n  "args": {},\n  "headers": {\n    "Accept": "*/*",\n    "Host": "httpbin.org",\n    "User-Agent": "curl/7.58.0",\n    "X-Amzn-Trace-Id": "Root=1-5eaf8e77-efcb353b0983ad6a90f8bdcd"\n  },\n  "origin": "...",\n  "url": "https://httpbin.org/get"\n}\n* Connection #0 to host 127.0.0.1 left intact\n```\n\n### HTTP API\n#### Get info of proxy been used for retrieving specific url\nFor HTTP, it\'s easy.\n```\n$ http_proxy=http://127.0.0.1:8888 https_proxy=http://127.0.0.1:8888 curl -v http://proxycontrol/api/history/url:http://httpbin.org/get\n*   Trying 127.0.0.1...\n* TCP_NODELAY set\n* Connected to 127.0.0.1 (127.0.0.1) port 8888 (#0)\n> GET http://proxycontrol/api/history/url:http://httpbin.org/get HTTP/1.1\n> Host: proxycontrol\n> User-Agent: curl/7.58.0\n> Accept: */*\n> Proxy-Connection: Keep-Alive\n>\n< HTTP/1.1 200 OK\n< Content-Type: application/json\n< Content-Length: 34\n< Access-Control-Allow-Origin: *\n< Access-Control-Allow-Credentials: true\n<\n{"proxy": "..."}\n```\n\nFor HTTPS, we\'re not able to know encrypted payload (request), so only hostname can be used.\n```\n$ http_proxy=http://127.0.0.1:8888 https_proxy=http://127.0.0.1:8888 curl -v http://proxycontrol/api/history/url:httpbin.org:443\n*   Trying 127.0.0.1...\n* TCP_NODELAY set\n* Connected to 127.0.0.1 (127.0.0.1) port 8888 (#0)\n> GET http://proxycontrol/api/history/url:httpbin.org:443 HTTP/1.1\n> Host: proxycontrol\n> User-Agent: curl/7.58.0\n> Accept: */*\n> Proxy-Connection: Keep-Alive\n>\n< HTTP/1.1 200 OK\n< Content-Type: application/json\n< Content-Length: 34\n< Access-Control-Allow-Origin: *\n< Access-Control-Allow-Credentials: true\n<\n{"proxy": "..."}\n* Connection #0 to host 127.0.0.1 left intact\n```\n\n#### Remove specific proxy from queue\n```\n$ http_proxy=http://127.0.0.1:8888 https_proxy=http://127.0.0.1:8888 curl -v http://proxycontrol/api/remove/PROXY_IP:PROXY_PORT\n*   Trying 127.0.0.1...\n* TCP_NODELAY set\n* Connected to 127.0.0.1 (127.0.0.1) port 8888 (#0)\n> GET http://proxycontrol/api/remove/... HTTP/1.1\n> Host: proxycontrol\n> User-Agent: curl/7.58.0\n> Accept: */*\n> Proxy-Connection: Keep-Alive\n>\n< HTTP/1.1 204 No Content\n<\n* Connection #0 to host 127.0.0.1 left intact\n```\n\nDocumentation\n-------------\n\n<https://proxybroker.readthedocs.io/>\n\nTODO\n----\n\n-   Check the ping, response time and speed of data transfer\n-   Check site access (Google, Twitter, etc) and even your own custom URL\'s\n-   Information about uptime\n-   Checksum of data returned\n-   Support for proxy authentication\n-   Finding outgoing IP for cascading proxy\n-   The ability to specify the address of the proxy without port (try to connect on defaulted ports)\n\nContributing\n------------\n\n-   Fork it: <https://github.com/bluet/proxybroker2/fork>\n-   Create your feature branch: `git checkout -b my-new-feature`\n-   Commit your changes: `git commit -am \'Add some feature\'`\n-   Push to the branch: `git push origin my-new-feature`\n-   Submit a pull request!\n-   [Contributor workflow](https://github.com/bluet/proxybroker2/issues/93)\n\nLicense\n-------\n\nLicensed under the Apache License, Version 2.0\n\n*This product includes GeoLite2 data created by MaxMind, available from* [<http://www.maxmind.com>](http://www.maxmind.com).\n\nRefs\n----\n\n-   <https://github.com/constverum/ProxyBroker/pull/161>\n\n## Contributors ✨\n\nThanks goes to these wonderful people ([emoji key](https://allcontributors.org/docs/en/emoji-key)):\n\n<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->\n<!-- prettier-ignore-start -->\n<!-- markdownlint-disable -->\n<table>\n  <tr>\n    <td align="center"><a href="https://github.com/a5r0n"><img src="https://avatars.githubusercontent.com/u/32464596?v=4?s=100" width="100px;" alt=""/><br /><sub><b>a5r0n</b></sub></a><br /><a href="https://github.com/bluet/proxybroker2/commits?author=a5r0n" title="Code">💻</a></td>\n    <td align="center"><a href="https://afun.tw"><img src="https://avatars.githubusercontent.com/u/4820492?v=4?s=100" width="100px;" alt=""/><br /><sub><b>C.M. Yang</b></sub></a><br /><a href="https://github.com/bluet/proxybroker2/commits?author=afunTW" title="Code">💻</a> <a href="#ideas-afunTW" title="Ideas, Planning, & Feedback">🤔</a> <a href="https://github.com/bluet/proxybroker2/pulls?q=is%3Apr+reviewed-by%3AafunTW" title="Reviewed Pull Requests">👀</a></td>\n    <td align="center"><a href="http://ivanvillareal.com"><img src="https://avatars.githubusercontent.com/u/190708?v=4?s=100" width="100px;" alt=""/><br /><sub><b>Ivan Villareal</b></sub></a><br /><a href="https://github.com/bluet/proxybroker2/commits?author=ivaano" title="Code">💻</a></td>\n    <td align="center"><a href="https://github.com/quancore"><img src="https://avatars.githubusercontent.com/u/15036825?v=4?s=100" width="100px;" alt=""/><br /><sub><b>Quancore</b></sub></a><br /><a href="https://github.com/bluet/proxybroker2/commits?author=quancore" title="Code">💻</a></td>\n    <td align="center"><a href="https://github.com/synchronizing"><img src="https://avatars.githubusercontent.com/u/2829082?v=4?s=100" width="100px;" alt=""/><br /><sub><b>Felipe</b></sub></a><br /><a href="#ideas-synchronizing" title="Ideas, Planning, & Feedback">🤔</a></td>\n    <td align="center"><a href="https://www.vincentinttsh.tw/"><img src="https://avatars.githubusercontent.com/u/14941597?v=4?s=100" width="100px;" alt=""/><br /><sub><b>vincentinttsh</b></sub></a><br /><a href="https://github.com/bluet/proxybroker2/commits?author=vincentinttsh" title="Code">💻</a> <a href="https://github.com/bluet/proxybroker2/pulls?q=is%3Apr+reviewed-by%3Avincentinttsh" title="Reviewed Pull Requests">👀</a></td>\n    <td align="center"><a href="https://github.com/ziloka"><img src="https://avatars.githubusercontent.com/u/50429450?v=4?s=100" width="100px;" alt=""/><br /><sub><b>Ziloka</b></sub></a><br /><a href="https://github.com/bluet/proxybroker2/commits?author=ziloka" title="Code">💻</a></td>\n  </tr>\n  <tr>\n    <td align="center"><a href="http://hhming.moe"><img src="https://avatars.githubusercontent.com/u/43672033?v=4?s=100" width="100px;" alt=""/><br /><sub><b>hms5232</b></sub></a><br /><a href="https://github.com/bluet/proxybroker2/commits?author=hms5232" title="Code">💻</a></td>\n  </tr>\n</table>\n\n<!-- markdownlint-restore -->\n<!-- prettier-ignore-end -->\n\n<!-- ALL-CONTRIBUTORS-LIST:END -->\n\nThis project follows the [all-contributors](https://github.com/all-contributors/all-contributors) specification. Contributions of any kind welcome!\n',
    'author': 'BlueT - Matthew Lien - 練喆明',
    'author_email': 'bluet@bluet.org',
    'maintainer': 'None',
    'maintainer_email': 'None',
    'url': 'http://proxybroker.readthedocs.io/',
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'entry_points': entry_points,
    'python_requires': '>=3.8,<4.0',
}


setup(**setup_kwargs)
